//
//  NDKSimpleFieldToClassMapper.m
//  NetDataKit
//
// Copyright (c) 2012, Paul C. Hoehne
// All rights reserved.
//
// Redistribution and use in source and binary forms, with 
// or without modification, are permitted provided that the 
// following conditions are met:
//
// Redistributions of source code must retain the above 
// copyright notice, this list of conditions and the 
// following disclaimer.
// 
// Redistributions in binary form must reproduce the above 
// copyright notice, this list of conditions and the 
// following disclaimer in the documentation and/or other 
// materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
// CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR 
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
// BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
// DAMAGE.
//

#import "NDKSimpleFieldToClassMapper.h"
#import "NDKDataSource.h"
#import "NDKErrorReport.h"

@implementation NDKSimpleFieldToClassMapper

@synthesize objectClass, mapping;

-(id) createInstance {
    return [[objectClass alloc] init];
}

-(id) mapValues: (NSDictionary*)values withMapping: (NSDictionary*) map onObject: (id)object {
    if([values count] != [map count]) {
        
    } else {
        for (NSString* key in [map allKeys]) {
            [object setValue:[values objectForKey:key] forKey:[map objectForKey:key]];
        }
    }
    
    return object;
}

-(NSArray*) mapFields: (NSArray*)rawData forSource: (NDKDataSource*)source {
    NSMutableArray* result = [[NSMutableArray alloc] init];
    for (NSDictionary* values in rawData) {
        [result addObject: [self mapValues:values withMapping:mapping onObject:[self createInstance]]];
    }
    return result;
}

@end
